# -*- coding: utf-8 -*-

from __future__ import division

from django_response import response
from paginator import pagination

from registration.models import CourseRegisterInfo, UserCourseRegisterInfo


def course_register(request):
    user_id = request.POST.get('user_id', '')
    field_id = request.POST.get('field_id', '')
    course_id = request.POST.get('course_id', '')
    course_name = request.POST.get('course_name', '')
    fields = request.POST.get('fields', [])

    CourseRegisterInfo.objects.update_or_create(user_id=user_id, field_id=field_id, course_id=course_id, defaults={
        'course_name': course_name,
        'fields': fields,
    })

    registers = CourseRegisterInfo.objects.filter(user_id=user_id, course_id=course_id, status=True)
    registers = [register.data for register in registers]

    UserCourseRegisterInfo.objects.update_or_create(user_id, course_id, defaults={
        'course_name': course_name,
        'fields': registers,
    })

    return response()


def course_register_list(request):
    course_id = request.POST.get('course_id', '')
    page = request.POST.get('page', 1)
    num = request.POST.get('num', 20)

    registers = UserCourseRegisterInfo.objects.filter(course_id=course_id, status=True).order_by('-pk')
    count = registers.count()
    registers, left = pagination(registers, page, num)
    registers = [register.data for register in registers]

    return response(data={
        'logs': registers,
        'count': count,
        'left': left,
    })
